@ECHO OFF
SETLOCAL ENABLEEXTENSIONS
SETLOCAL ENABLEDELAYEDEXPANSION
IF %1.==. GOTO :USAGE
IF NOT EXIST %1 ECHO ERROR, %1 is missing.&PAUSE&GOTO :EOF
IF NOT EXIST CS.EXE ECHO ERROR, CS.EXE is missing!&PAUSE&GOTO :EOF

FOR /F "tokens=3 delims==" %%A IN ('cs %1') DO SET NOW_CS=%%A

IF %2.==. SET WANTED_CS=FFFFFFFF &GOTO :Start
SET WANTED_CS=%2
FOR %%A IN (1 2 3 4 5 6 7) DO (
SET Check=!WANTED_CS:~0,%%A!
IF %WANTED_CS%==!Check! ECHO ERROR, New_Checksum must be 8 chars long.&PAUSE&GOTO :EOF
)
Set Counter=
FOR %%A IN (0 1 2 3 4 5 6 7) DO (
SET Check=!WANTED_CS:~%%A,1!
FOR %%B IN (0 1 2 3 4 5 6 7 8 9 A B C D E F) DO (
IF !Check!==%%B SET /A Counter=!Counter!+1
)
)
IF !Counter! LSS 8 ECHO ERROR, only characters 0123456789ABCDEF allowed.&PAUSE&GOTO :EOF

:Start
ECHO CURRENT CHECKSUM IS %NOW_CS%
ECHO.
ECHO WANTED  CHECKSUM IS %WANTED_CS%
ECHO.
SET DELTA_CS=%NOW_CS:~6,2%%NOW_CS:~4,2%%NOW_CS:~2,2%%NOW_CS:~0,2%
CALL :ENCODE %DELTA_CS%
CALL :COMPL %DELTA_CS%

Set First=%DELTA_CS:~6,2%%DELTA_CS:~4,2%%DELTA_CS:~2,2%%DELTA_CS:~0,2%
Set Second=00000001
CALL :DoSum

Set First=%SUM%
Set Second=%WANTED_CS%
CALL :DoSum

SET DELTA_CS=%SUM:~6,2% %SUM:~4,2% %SUM:~2,2% %SUM:~0,2%
ECHO To have Checksum=%WANTED_CS%
ECHO Write these values: 
ECHO %DELTA_CS% 

ECHO.
GOTO :EOF

:DoSum
FOR %%A IN (0 1 2 3 4 5 6 7) DO SET First%%A=!First:~%%A,1!
FOR %%A IN (0 1 2 3 4 5 6 7) DO SET Second%%A=!Second:~%%A,1!
FOR %%A IN (7 6 5 4 3 2 1 0) DO SET /A SUM%%A=0x!First%%A!+0x!Second%%A!
FOR %%A IN (7 6 5 4 3 2 1 0) DO CALL :CarryFlag %%A
FOR %%A IN (7 6 5 4 3 2 1 0) DO CALL :dectohex SUM%%A
SET SUM=
FOR %%A IN (0 1 2 3 4 5 6 7) DO SET SUM=!SUM!!SUM%%A!
GOTO :EOF

:dectohex
IF !%1!==10 SET %1=A
IF !%1!==11 SET %1=B
IF !%1!==12 SET %1=C
IF !%1!==13 SET %1=D
IF !%1!==14 SET %1=E
IF !%1!==15 SET %1=F
GOTO :EOF

:CarryFlag
SET /A NEXT=%1-1
IF %NEXT%==-1 SET NEXT=8
IF !SUM%1! GTR 15 SET /A SUM%1=!SUM%1!-16&SET /A SUM%NEXT%=!SUM%NEXT%!+1
GOTO :EOF

:: These routines come from Capitalize published by Frank-Peter Schultze
:: http://www.fpschultze.de/smartfaq+faq.faqid+262.htm
:: and modifiedied by me (jaclaz)
:: First we "encode" the string with this substitution table:
:: 0123456789ABCDEF
:: ghijklmnopqrstuv
:: And later we "decode" the string with this substitution table:
:: ghijklmnopqrstuv
:: FEDCBA9876543210
:: Representing the complement to 15 or 0XF of the first table


:ENCODE
Set s=%1
For %%A In (0g 1h 2i 3j 4k 5l 6m 7n 8o 9p Aq Br Cs Dt Eu Fv) Do Call :MyShuffle %%A
SET DELTA_CS=%S%
GOTO :EOF

:COMPL
Set s=%1
For %%A In (gF hE iD jC kB lA m9 n8 o7 p6 q5 r4 s3 t2 u1 v0) Do Call :MyShuffle %%A
SET DELTA_CS=%S%
GOTO :EOF

:MyShuffle
Set _=%1
Call Set s=%%s:%_:~0,1%=%_:~1,1%%%
Goto :EOF

:USAGE
ECHO USAGE:
ECHO %~nx0% File [New_Checksum]
ECHO.
ECHO where File has to be a copy of the MBR (512 bytes)
ECHO and [New_checksum] is the new Checksum you want it to have
ECHO If  [New_checksum] is missing, it is assumed to be FFFFFFFF
ECHO.
ECHO The batch will produce the hex values you need to write
ECHO with a hex editor in an unused space of the MBR file
ECHO suggested location is bytes at hex offset 1B0 to 1B3 or 432 to 435 dec
